# Generated by Django 5.2 on 2024-11-15 12:53

import django.core.validators
import django.db.models.deletion
import lnschema_core.fields
import lnschema_core.ids
import lnschema_core.models
import lnschema_core.users
from django.db import migrations, models


class Migration(migrations.Migration):
    dependencies = [
        ("findrefs", "0001_initial"),
        (
            "lnschema_core",
            "0069_alter_artifact__accessor_alter_artifact__hash_type_and_more",
        ),
    ]

    operations = [
        migrations.AlterField(
            model_name="artifactreference",
            name="artifact",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="links_reference",
                to="lnschema_core.artifact",
            ),
        ),
        migrations.AlterField(
            model_name="artifactreference",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="artifactreference",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="artifactreference",
            name="feature",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=None,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="links_artifactreference",
                to="lnschema_core.feature",
            ),
        ),
        migrations.AlterField(
            model_name="artifactreference",
            name="feature_ref_is_name",
            field=lnschema_core.fields.BooleanField(
                blank=True, default=None, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifactreference",
            name="label_ref_is_name",
            field=lnschema_core.fields.BooleanField(
                blank=True, default=None, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifactreference",
            name="reference",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="links_artifact",
                to="findrefs.reference",
            ),
        ),
        migrations.AlterField(
            model_name="artifactreference",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.models.current_run,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="reference",
            name="abbr",
            field=lnschema_core.fields.CharField(
                blank=True,
                db_index=True,
                default=None,
                max_length=32,
                null=True,
                unique=True,
            ),
        ),
        migrations.AlterField(
            model_name="reference",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="reference",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="reference",
            name="doi",
            field=lnschema_core.fields.CharField(
                blank=True,
                db_index=True,
                default=None,
                max_length=255,
                null=True,
                validators=[
                    django.core.validators.RegexValidator(
                        message="Must be a DOI (e.g., 10.1000/xyz123 or https://doi.org/10.1000/xyz123)",
                        regex="^(?:https?://(?:dx\\.)?doi\\.org/|doi:|DOI:)?10\\.\\d+/.*$",
                    )
                ],
            ),
        ),
        migrations.AlterField(
            model_name="reference",
            name="name",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=255
            ),
        ),
        migrations.AlterField(
            model_name="reference",
            name="pubmed_id",
            field=lnschema_core.fields.BigIntegerField(blank=True, null=True),
        ),
        migrations.AlterField(
            model_name="reference",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.models.current_run,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="reference",
            name="text",
            field=lnschema_core.fields.TextField(blank=True, default=None, null=True),
        ),
        migrations.AlterField(
            model_name="reference",
            name="uid",
            field=lnschema_core.fields.CharField(
                blank=True,
                default=lnschema_core.ids.base62_12,
                max_length=12,
                unique=True,
            ),
        ),
        migrations.AlterField(
            model_name="reference",
            name="updated_at",
            field=lnschema_core.fields.DateTimeField(auto_now=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="reference",
            name="url",
            field=models.URLField(blank=True, null=True),
        ),
    ]
