# Generated by Django 5.2 on 2024-11-14 21:08

import django.db.models.deletion
from django.db import migrations

import lnschema_core.fields
import lnschema_core.ids
import lnschema_core.models
import lnschema_core.users


class Migration(migrations.Migration):
    dependencies = [
        ("lnschema_core", "0068_alter_artifactulabel_unique_together_and_more"),
    ]

    operations = [
        migrations.AlterField(
            model_name="artifact",
            name="_accessor",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=64, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="_hash_type",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=30, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="_key_is_virtual",
            field=lnschema_core.fields.BooleanField(blank=True, default=None),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="created_artifacts",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="description",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=255, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="hash",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=22, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="is_latest",
            field=lnschema_core.fields.BooleanField(
                blank=True, db_index=True, default=True
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="key",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=255, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="n_objects",
            field=lnschema_core.fields.BigIntegerField(
                blank=True, db_index=True, default=None, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="n_observations",
            field=lnschema_core.fields.BigIntegerField(
                blank=True, db_index=True, default=None, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=None,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="output_artifacts",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="size",
            field=lnschema_core.fields.BigIntegerField(
                blank=True, db_index=True, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="storage",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="artifacts",
                to="lnschema_core.storage",
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="suffix",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=30
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="transform",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=None,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="output_artifacts",
                to="lnschema_core.transform",
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="type",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=20, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="uid",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=20, unique=True
            ),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="updated_at",
            field=lnschema_core.fields.DateTimeField(auto_now=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="artifact",
            name="version",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=30, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifactfeatureset",
            name="artifact",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="links_feature_set",
                to="lnschema_core.artifact",
            ),
        ),
        migrations.AlterField(
            model_name="artifactfeatureset",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="artifactfeatureset",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="artifactfeatureset",
            name="feature_ref_is_semantic",
            field=lnschema_core.fields.BooleanField(
                blank=True, default=None, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifactfeatureset",
            name="featureset",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="links_artifact",
                to="lnschema_core.featureset",
            ),
        ),
        migrations.AlterField(
            model_name="artifactfeatureset",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.models.current_run,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="artifactfeatureset",
            name="slot",
            field=lnschema_core.fields.CharField(
                blank=True, default=None, max_length=40, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifactfeaturevalue",
            name="artifact",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="+",
                to="lnschema_core.artifact",
            ),
        ),
        migrations.AlterField(
            model_name="artifactfeaturevalue",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="artifactfeaturevalue",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="artifactfeaturevalue",
            name="featurevalue",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.featurevalue",
            ),
        ),
        migrations.AlterField(
            model_name="artifactfeaturevalue",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.models.current_run,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="artifactparamvalue",
            name="artifact",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="+",
                to="lnschema_core.artifact",
            ),
        ),
        migrations.AlterField(
            model_name="artifactparamvalue",
            name="paramvalue",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.paramvalue",
            ),
        ),
        migrations.AlterField(
            model_name="artifactulabel",
            name="artifact",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="links_ulabel",
                to="lnschema_core.artifact",
            ),
        ),
        migrations.AlterField(
            model_name="artifactulabel",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="artifactulabel",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="artifactulabel",
            name="feature",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=None,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="links_artifactulabel",
                to="lnschema_core.feature",
            ),
        ),
        migrations.AlterField(
            model_name="artifactulabel",
            name="feature_ref_is_name",
            field=lnschema_core.fields.BooleanField(
                blank=True, default=None, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifactulabel",
            name="label_ref_is_name",
            field=lnschema_core.fields.BooleanField(
                blank=True, default=None, null=True
            ),
        ),
        migrations.AlterField(
            model_name="artifactulabel",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.models.current_run,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="artifactulabel",
            name="ulabel",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="links_artifact",
                to="lnschema_core.ulabel",
            ),
        ),
        migrations.AlterField(
            model_name="collection",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="collection",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="collection",
            name="description",
            field=lnschema_core.fields.TextField(blank=True, default=None, null=True),
        ),
        migrations.AlterField(
            model_name="collection",
            name="hash",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=22, null=True
            ),
        ),
        migrations.AlterField(
            model_name="collection",
            name="is_latest",
            field=lnschema_core.fields.BooleanField(
                blank=True, db_index=True, default=True
            ),
        ),
        migrations.AlterField(
            model_name="collection",
            name="name",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=150
            ),
        ),
        migrations.AlterField(
            model_name="collection",
            name="reference",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=255, null=True
            ),
        ),
        migrations.AlterField(
            model_name="collection",
            name="reference_type",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=25, null=True
            ),
        ),
        migrations.AlterField(
            model_name="collection",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=None,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="output_collections",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="collection",
            name="transform",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=None,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="output_collections",
                to="lnschema_core.transform",
            ),
        ),
        migrations.AlterField(
            model_name="collection",
            name="uid",
            field=lnschema_core.fields.CharField(
                blank=True,
                db_index=True,
                default=lnschema_core.ids.base62_20,
                max_length=20,
                unique=True,
            ),
        ),
        migrations.AlterField(
            model_name="collection",
            name="updated_at",
            field=lnschema_core.fields.DateTimeField(auto_now=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="collection",
            name="version",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=30, null=True
            ),
        ),
        migrations.AlterField(
            model_name="collection",
            name="meta_artifact",
            field=lnschema_core.fields.OneToOneField(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="_meta_of_collection",
                to="lnschema_core.artifact",
            ),
        ),
        migrations.AlterField(
            model_name="collectionartifact",
            name="artifact",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="links_collection",
                to="lnschema_core.artifact",
            ),
        ),
        migrations.AlterField(
            model_name="collectionartifact",
            name="collection",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="links_artifact",
                to="lnschema_core.collection",
            ),
        ),
        migrations.AlterField(
            model_name="collectionartifact",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="collectionartifact",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="collectionartifact",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.models.current_run,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="collectionulabel",
            name="collection",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="links_ulabel",
                to="lnschema_core.collection",
            ),
        ),
        migrations.AlterField(
            model_name="collectionulabel",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="collectionulabel",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="collectionulabel",
            name="feature",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=None,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="links_collectionulabel",
                to="lnschema_core.feature",
            ),
        ),
        migrations.AlterField(
            model_name="collectionulabel",
            name="feature_ref_is_name",
            field=lnschema_core.fields.BooleanField(
                blank=True, default=None, null=True
            ),
        ),
        migrations.AlterField(
            model_name="collectionulabel",
            name="label_ref_is_name",
            field=lnschema_core.fields.BooleanField(
                blank=True, default=None, null=True
            ),
        ),
        migrations.AlterField(
            model_name="collectionulabel",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.models.current_run,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="collectionulabel",
            name="ulabel",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="links_collection",
                to="lnschema_core.ulabel",
            ),
        ),
        migrations.AlterField(
            model_name="feature",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="feature",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="feature",
            name="description",
            field=lnschema_core.fields.TextField(
                blank=True, db_index=True, default=None, null=True
            ),
        ),
        migrations.AlterField(
            model_name="feature",
            name="dtype",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=64
            ),
        ),
        migrations.AlterField(
            model_name="feature",
            name="name",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=150, unique=True
            ),
        ),
        migrations.AlterField(
            model_name="feature",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.models.current_run,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="feature",
            name="synonyms",
            field=lnschema_core.fields.TextField(blank=True, default=None, null=True),
        ),
        migrations.AlterField(
            model_name="feature",
            name="uid",
            field=lnschema_core.fields.CharField(
                blank=True,
                db_index=True,
                default=lnschema_core.ids.base62_12,
                max_length=12,
                unique=True,
            ),
        ),
        migrations.AlterField(
            model_name="feature",
            name="unit",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=30, null=True
            ),
        ),
        migrations.AlterField(
            model_name="feature",
            name="updated_at",
            field=lnschema_core.fields.DateTimeField(auto_now=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="featureset",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="featureset",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="featureset",
            name="dtype",
            field=lnschema_core.fields.CharField(
                blank=True, default=None, max_length=64, null=True
            ),
        ),
        migrations.AlterField(
            model_name="featureset",
            name="hash",
            field=lnschema_core.fields.CharField(
                blank=True,
                db_index=True,
                default=None,
                max_length=22,
                null=True,
                unique=True,
            ),
        ),
        migrations.AlterField(
            model_name="featureset",
            name="n",
            field=lnschema_core.fields.IntegerField(blank=True),
        ),
        migrations.AlterField(
            model_name="featureset",
            name="name",
            field=lnschema_core.fields.CharField(
                blank=True, default=None, max_length=150, null=True
            ),
        ),
        migrations.AlterField(
            model_name="featureset",
            name="registry",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=120
            ),
        ),
        migrations.AlterField(
            model_name="featureset",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.models.current_run,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="featureset",
            name="uid",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=20, unique=True
            ),
        ),
        migrations.AlterField(
            model_name="featuresetfeature",
            name="feature",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.feature",
            ),
        ),
        migrations.AlterField(
            model_name="featuresetfeature",
            name="featureset",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="+",
                to="lnschema_core.featureset",
            ),
        ),
        migrations.AlterField(
            model_name="featurevalue",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="featurevalue",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="featurevalue",
            name="feature",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=None,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="values",
                to="lnschema_core.feature",
            ),
        ),
        migrations.AlterField(
            model_name="featurevalue",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.models.current_run,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="param",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="param",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="param",
            name="dtype",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=64
            ),
        ),
        migrations.AlterField(
            model_name="param",
            name="name",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=100
            ),
        ),
        migrations.AlterField(
            model_name="param",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.models.current_run,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="param",
            name="updated_at",
            field=lnschema_core.fields.DateTimeField(auto_now=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="paramvalue",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="paramvalue",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="paramvalue",
            name="param",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="values",
                to="lnschema_core.param",
            ),
        ),
        migrations.AlterField(
            model_name="run",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="run",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="created_runs",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="run",
            name="environment",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=None,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="_environment_of",
                to="lnschema_core.artifact",
            ),
        ),
        migrations.AlterField(
            model_name="run",
            name="finished_at",
            field=lnschema_core.fields.DateTimeField(
                blank=True, db_index=True, default=None, null=True
            ),
        ),
        migrations.AlterField(
            model_name="run",
            name="is_consecutive",
            field=lnschema_core.fields.BooleanField(
                blank=True, default=None, null=True
            ),
        ),
        migrations.AlterField(
            model_name="run",
            name="parent",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=None,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="children",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="run",
            name="reference",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=255, null=True
            ),
        ),
        migrations.AlterField(
            model_name="run",
            name="reference_type",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=25, null=True
            ),
        ),
        migrations.AlterField(
            model_name="run",
            name="report",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=None,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="_report_of",
                to="lnschema_core.artifact",
            ),
        ),
        migrations.AlterField(
            model_name="run",
            name="started_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="run",
            name="transform",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="runs",
                to="lnschema_core.transform",
            ),
        ),
        migrations.AlterField(
            model_name="run",
            name="uid",
            field=lnschema_core.fields.CharField(
                blank=True,
                db_index=True,
                default=lnschema_core.ids.base62_20,
                max_length=20,
                unique=True,
            ),
        ),
        migrations.AlterField(
            model_name="runparamvalue",
            name="paramvalue",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.paramvalue",
            ),
        ),
        migrations.AlterField(
            model_name="runparamvalue",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="+",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="storage",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="storage",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="storage",
            name="description",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=255, null=True
            ),
        ),
        migrations.AlterField(
            model_name="storage",
            name="instance_uid",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=12, null=True
            ),
        ),
        migrations.AlterField(
            model_name="storage",
            name="region",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=64, null=True
            ),
        ),
        migrations.AlterField(
            model_name="storage",
            name="root",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=255, unique=True
            ),
        ),
        migrations.AlterField(
            model_name="storage",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.models.current_run,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="storage",
            name="type",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=30
            ),
        ),
        migrations.AlterField(
            model_name="storage",
            name="uid",
            field=lnschema_core.fields.CharField(
                blank=True,
                db_index=True,
                default=lnschema_core.ids.base62_12,
                max_length=12,
                unique=True,
            ),
        ),
        migrations.AlterField(
            model_name="storage",
            name="updated_at",
            field=lnschema_core.fields.DateTimeField(auto_now=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="transform",
            name="_source_code_artifact",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=None,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="_source_code_of",
                to="lnschema_core.artifact",
            ),
        ),
        migrations.AlterField(
            model_name="transform",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="transform",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="created_transforms",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="transform",
            name="description",
            field=lnschema_core.fields.CharField(
                blank=True, default=None, max_length=255, null=True
            ),
        ),
        migrations.AlterField(
            model_name="transform",
            name="hash",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=22, null=True
            ),
        ),
        migrations.AlterField(
            model_name="transform",
            name="is_latest",
            field=lnschema_core.fields.BooleanField(
                blank=True, db_index=True, default=True
            ),
        ),
        migrations.AlterField(
            model_name="transform",
            name="key",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=120, null=True
            ),
        ),
        migrations.AlterField(
            model_name="transform",
            name="name",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=150, null=True
            ),
        ),
        migrations.AlterField(
            model_name="transform",
            name="reference",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=255, null=True
            ),
        ),
        migrations.AlterField(
            model_name="transform",
            name="reference_type",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=25, null=True
            ),
        ),
        migrations.AlterField(
            model_name="transform",
            name="source_code",
            field=lnschema_core.fields.TextField(blank=True, default=None, null=True),
        ),
        migrations.AlterField(
            model_name="transform",
            name="type",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default="pipeline", max_length=20
            ),
        ),
        migrations.AlterField(
            model_name="transform",
            name="uid",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=16, unique=True
            ),
        ),
        migrations.AlterField(
            model_name="transform",
            name="updated_at",
            field=lnschema_core.fields.DateTimeField(auto_now=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="transform",
            name="version",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=30, null=True
            ),
        ),
        migrations.AlterField(
            model_name="ulabel",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="ulabel",
            name="created_by",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.users.current_user_id,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.user",
            ),
        ),
        migrations.AlterField(
            model_name="ulabel",
            name="description",
            field=lnschema_core.fields.TextField(blank=True, default=None, null=True),
        ),
        migrations.AlterField(
            model_name="ulabel",
            name="name",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=150, unique=True
            ),
        ),
        migrations.AlterField(
            model_name="ulabel",
            name="reference",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=255, null=True
            ),
        ),
        migrations.AlterField(
            model_name="ulabel",
            name="reference_type",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=25, null=True
            ),
        ),
        migrations.AlterField(
            model_name="ulabel",
            name="run",
            field=lnschema_core.fields.ForeignKey(
                blank=True,
                default=lnschema_core.models.current_run,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="lnschema_core.run",
            ),
        ),
        migrations.AlterField(
            model_name="ulabel",
            name="uid",
            field=lnschema_core.fields.CharField(
                blank=True,
                db_index=True,
                default=lnschema_core.ids.base62_8,
                max_length=8,
                unique=True,
            ),
        ),
        migrations.AlterField(
            model_name="ulabel",
            name="updated_at",
            field=lnschema_core.fields.DateTimeField(auto_now=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="user",
            name="created_at",
            field=lnschema_core.fields.DateTimeField(auto_now_add=True, db_index=True),
        ),
        migrations.AlterField(
            model_name="user",
            name="handle",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=30, unique=True
            ),
        ),
        migrations.AlterField(
            model_name="user",
            name="name",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=150, null=True
            ),
        ),
        migrations.AlterField(
            model_name="user",
            name="uid",
            field=lnschema_core.fields.CharField(
                blank=True, db_index=True, default=None, max_length=8, unique=True
            ),
        ),
        migrations.AlterField(
            model_name="user",
            name="updated_at",
            field=lnschema_core.fields.DateTimeField(auto_now=True, db_index=True),
        ),
    ]
